Bug 201481

Summary: Layout Test imported/w3c/web-platform-tests/IndexedDB/fire-error-event-exception.html is a Flaky Failure
Product: WebKit Reporter: Russell Epstein <repstein>
Component: WebCore Misc.Assignee: Sihui Liu <sihui_liu>
Status: REOPENED ---    
Severity: Normal CC: achristensen, alecflett, ap, beidson, cdumez, commit-queue, ews-watchlist, jlewis3, jsbell, ryanhaddad, webkit-bot-watchers-bugzilla, webkit-bug-importer, youennf
Priority: P2 Keywords: InRadar
Version: WebKit Nightly Build   
Hardware: Unspecified   
OS: Unspecified   
See Also: https://bugs.webkit.org/show_bug.cgi?id=169621
https://bugs.webkit.org/show_bug.cgi?id=169760
Attachments:
Description Flags
Patch
none
Archive of layout-test-results from ews210 for win-future
none
Patch
none
Patch
none
Archive of layout-test-results from webkit-cq-01
none
Archive of layout-test-results from webkit-cq-01
none
Archive of layout-test-results from webkit-cq-03
none
Archive of layout-test-results from webkit-cq-01
none
Archive of layout-test-results from webkit-cq-03
none
Archive of layout-test-results from webkit-cq-02
none
Archive of layout-test-results from webkit-cq-02
none
Archive of layout-test-results from webkit-cq-03 none

Description Russell Epstein 2019-09-04 16:58:25 PDT
The following layout test is a flaky failure on all platforms:

imported/w3c/web-platform-tests/IndexedDB/fire-error-event-exception.html

This test is failing in a very similar way to the issue stated (and "resolved") in bug 169621. The test is outputting the proper content, but the content is not always in the correct order (test not properly waiting/race?).

Steps to Reproduce:

run-webkit-tests --iter 100 -f imported/w3c/web-platform-tests/IndexedDB/fire-error-event-exception.html

Test History:
https://webkit-test-results.webkit.org/dashboards/flakiness_dashboard.html#tests=imported%2Fw3c%2Fweb-platform-tests%2FIndexedDB%2Ffire-error-event-exception.html%20

Diff:

--- /Volumes/Data/slave/mojave-debug-tests-wk2/build/layout-test-results/imported/w3c/web-platform-tests/IndexedDB/fire-error-event-exception-expected.txt
+++ /Volumes/Data/slave/mojave-debug-tests-wk2/build/layout-test-results/imported/w3c/web-platform-tests/IndexedDB/fire-error-event-exception-actual.txt
@@ -1,4 +1,3 @@
-CONSOLE MESSAGE: line 32: Error
 CONSOLE MESSAGE: line 42: Error
 CONSOLE MESSAGE: line 51: Error
 CONSOLE MESSAGE: line 63: Error
@@ -8,6 +7,7 @@
 CONSOLE MESSAGE: line 110: Error
 CONSOLE MESSAGE: line 122: Error
 CONSOLE MESSAGE: line 132: Error
+CONSOLE MESSAGE: line 32: Error
 CONSOLE MESSAGE: line 150: Error
 CONSOLE MESSAGE: line 160: Error
 CONSOLE MESSAGE: line 169: Error
Comment 1 Radar WebKit Bug Importer 2019-09-04 16:59:39 PDT
<rdar://problem/55046055>
Comment 2 Sihui Liu 2019-09-06 17:10:12 PDT
Created attachment 378254 [details]
Patch
Comment 3 EWS Watchlist 2019-09-06 18:45:50 PDT
Comment on attachment 378254 [details]
Patch

Attachment 378254 [details] did not pass win-ews (win):
Output: https://webkit-queues.webkit.org/results/13007997

Number of test failures exceeded the failure limit.
Comment 4 EWS Watchlist 2019-09-06 18:45:52 PDT
Created attachment 378261 [details]
Archive of layout-test-results from ews210 for win-future

The attached test failures were seen while running run-webkit-tests on the win-ews.
Bot: ews210  Port: win-future  Platform: CYGWIN_NT-10.0-17763-3.0.5-338.x86_64-x86_64-64bit
Comment 5 Sihui Liu 2019-09-09 11:00:16 PDT
Created attachment 378385 [details]
Patch
Comment 6 Ryan Haddad 2019-09-09 11:29:57 PDT
Will this fix take care of https://bugs.webkit.org/show_bug.cgi?id=169760, too?
Comment 7 Sihui Liu 2019-09-09 11:54:09 PDT
(In reply to Ryan Haddad from comment #6)
> Will this fix take care of https://bugs.webkit.org/show_bug.cgi?id=169760,
> too?

I think so. It looks like these two are the same cause. I am not seeing the error of 169760 with this patch.
Comment 8 Ryan Haddad 2019-09-11 21:07:31 PDT
EWS seems happy. Who should review this?
Comment 9 Chris Dumez 2019-09-11 21:34:47 PDT
Comment on attachment 378385 [details]
Patch

View in context: https://bugs.webkit.org/attachment.cgi?id=378385&action=review

> Source/WebCore/Modules/indexeddb/IDBTransaction.cpp:513
> +    WTFLogAlways("sihuil: [%p]IDBTransaction::commit()", this);

This should probably not be there.
Comment 10 Sihui Liu 2019-09-12 11:27:35 PDT
Created attachment 378663 [details]
Patch
Comment 11 Sihui Liu 2019-10-04 09:23:24 PDT
ping for review..
Comment 12 WebKit Commit Bot 2019-10-04 11:26:25 PDT
Comment on attachment 378663 [details]
Patch

Clearing flags on attachment: 378663

Committed r250732: <https://trac.webkit.org/changeset/250732>
Comment 13 WebKit Commit Bot 2019-10-04 11:26:27 PDT
All reviewed patches have been landed.  Closing bug.
Comment 14 Alexey Proskuryakov 2019-10-19 12:41:37 PDT
This test remains flaky - maybe even more then before, because the commit queue hit it twice recently

 PASS Exception in error event handler on request 
 PASS Exception in error event handler on request, with preventDefault 
 PASS Exception in error event listener on request 
 PASS Exception in error event listener ("handleEvent" lookup) on request 
 FAIL Exception in error event listener (non-callable "handleEvent") on request assert_equals: expected "AbortError" but got "ConstraintError"
-PASS Exception in second error event listener on request 
+TIMEOUT Exception in second error event listener on request Test timed out
 PASS Exception in first error event listener on request, transaction active in second 
-PASS Exception in error event handler on transaction 
-PASS Exception in error event handler on transaction, with preventDefault 
-PASS Exception in error event listener on transaction 
-PASS Exception in second error event listener on transaction 
+TIMEOUT Exception in error event handler on transaction Test timed out
+TIMEOUT Exception in error event handler on transaction, with preventDefault Test timed out
+TIMEOUT Exception in error event listener on transaction Test timed out
+TIMEOUT Exception in second error event listener on transaction Test timed out
 PASS Exception in first error event listener on transaction, transaction active in second 
-PASS Exception in error event handler on connection 
-PASS Exception in error event handler on connection, with preventDefault 
-PASS Exception in error event listener on connection 
-PASS Exception in second error event listener on connection 
+TIMEOUT Exception in error event handler on connection Test timed out
+TIMEOUT Exception in error event handler on connection, with preventDefault Test timed out
+TIMEOUT Exception in error event listener on connection Test timed out
+TIMEOUT Exception in second error event listener on connection Test timed out
 PASS Exception in first error event listener on connection, transaction active in second
Comment 15 Alexey Proskuryakov 2019-10-19 12:41:51 PDT
*** Bug 202799 has been marked as a duplicate of this bug. ***
Comment 16 WebKit Commit Bot 2019-12-06 10:07:21 PST
The commit-queue just saw imported/w3c/web-platform-tests/IndexedDB/fire-error-event-exception.html flake (text diff) while processing attachment 385018 [details] on bug 204949.
Bot: webkit-cq-01  Port: <class 'webkitpy.common.config.ports.MacPort'>  Platform: Mac OS X 10.13.6
Comment 17 WebKit Commit Bot 2019-12-06 10:07:22 PST
Created attachment 385024 [details]
Archive of layout-test-results from webkit-cq-01
Comment 18 WebKit Commit Bot 2020-01-03 07:27:36 PST
The commit-queue just saw imported/w3c/web-platform-tests/IndexedDB/fire-error-event-exception.html flake (text diff) while processing attachment 386673 [details] on bug 205326.
Bot: webkit-cq-01  Port: <class 'webkitpy.common.config.ports.MacPort'>  Platform: Mac OS X 10.13.6
Comment 19 WebKit Commit Bot 2020-01-03 07:27:37 PST
Created attachment 386683 [details]
Archive of layout-test-results from webkit-cq-01
Comment 20 WebKit Commit Bot 2020-01-07 14:06:53 PST
The commit-queue just saw imported/w3c/web-platform-tests/IndexedDB/fire-error-event-exception.html flake (text diff) while processing attachment 386899 [details] on bug 205833.
Bot: webkit-cq-03  Port: <class 'webkitpy.common.config.ports.MacPort'>  Platform: Mac OS X 10.13.6
Comment 21 WebKit Commit Bot 2020-01-07 14:06:54 PST
Created attachment 387029 [details]
Archive of layout-test-results from webkit-cq-03
Comment 22 WebKit Commit Bot 2020-01-13 10:28:23 PST
The commit-queue just saw imported/w3c/web-platform-tests/IndexedDB/fire-error-event-exception.html flake (text diff) while processing attachment 387522 [details] on bug 206160.
Bot: webkit-cq-01  Port: <class 'webkitpy.common.config.ports.MacPort'>  Platform: Mac OS X 10.13.6
Comment 23 WebKit Commit Bot 2020-01-13 10:28:26 PST
Created attachment 387544 [details]
Archive of layout-test-results from webkit-cq-01
Comment 24 WebKit Commit Bot 2020-01-18 11:27:54 PST
The commit-queue just saw imported/w3c/web-platform-tests/IndexedDB/fire-error-event-exception.html flake (text diff) while processing attachment 388151 [details] on bug 206473.
Bot: webkit-cq-03  Port: <class 'webkitpy.common.config.ports.MacPort'>  Platform: Mac OS X 10.14.6
Comment 25 WebKit Commit Bot 2020-01-18 11:27:56 PST
Created attachment 388155 [details]
Archive of layout-test-results from webkit-cq-03
Comment 26 WebKit Commit Bot 2020-01-21 12:33:10 PST
The commit-queue just saw imported/w3c/web-platform-tests/IndexedDB/fire-error-event-exception.html flake (text diff) while processing attachment 388326 [details] on bug 206460.
Bot: webkit-cq-02  Port: <class 'webkitpy.common.config.ports.MacPort'>  Platform: Mac OS X 10.14.6
Comment 27 WebKit Commit Bot 2020-01-21 12:33:11 PST
Created attachment 388334 [details]
Archive of layout-test-results from webkit-cq-02
Comment 28 WebKit Commit Bot 2020-01-22 18:44:29 PST
The commit-queue just saw imported/w3c/web-platform-tests/IndexedDB/fire-error-event-exception.html flake (text diff) while processing attachment 388495 [details] on bug 206449.
Bot: webkit-cq-02  Port: <class 'webkitpy.common.config.ports.MacPort'>  Platform: Mac OS X 10.14.6
Comment 29 WebKit Commit Bot 2020-01-22 18:44:31 PST
Created attachment 388507 [details]
Archive of layout-test-results from webkit-cq-02
Comment 30 WebKit Commit Bot 2020-01-29 11:19:13 PST
The commit-queue just saw imported/w3c/web-platform-tests/IndexedDB/fire-error-event-exception.html flake (text diff) while processing attachment 389123 [details] on bug 206899.
Bot: webkit-cq-03  Port: <class 'webkitpy.common.config.ports.MacPort'>  Platform: Mac OS X 10.14.6
Comment 31 WebKit Commit Bot 2020-01-29 11:19:14 PST
Created attachment 389163 [details]
Archive of layout-test-results from webkit-cq-03
Comment 32 Matt Lewis 2020-01-31 09:12:42 PST
*** Bug 169760 has been marked as a duplicate of this bug. ***
Comment 33 Matt Lewis 2020-01-31 09:32:27 PST
Marked as flaky for Jacob in https://trac.webkit.org/changeset/255502/webkit